; Dbut du script-fu ice-cube-logo_gimp_2_8.scm
;
; Accs par :   Fichier > Crer > Logos > Ice Cube...
; Et sur image RGBA avec un dessin par :  Filtres > Alpha vers logo > Ice Cube...
;

; origine : http://www.upstateforums.com/userfiles/gimp2.4scripts/icefire-logo.scm.zip
; 
; ice cube logo
;
; --------------------------------------------------------------------
; version 1.0 by Michael Schalla 2003/02/17
; version 2.0 by Eric Lamarque 2004/07/02
; version 3.0 ( modifications : register, autocrop, Absolute Size ) by samj (www.aljacom.com/~gimp) 2010/12/02
; version 3.1 ( modification pour gimp 2.7.2 ) by samj (www.aljacom.com/~gimp) 2010/12/09
; version 3.2 ( modification pour gimp 2.7.3 ) by samj (www.aljacom.com/~gimp) 2011/05/16
; version 3.3 ( modification pour gimp 2.8.0 ) by samj (www.aljacom.com/~gimp) 2012/05/07 ajouter un espace aprs le texte pour viter une perte sur la dernire lettre
; fix up for Gimp 2.10 legacy modes and histogram parameters - rich - july 2020
; --------------------------------------------------------------------
; Updated to Gimp2.4 (12/07)
; http://www.gimpscripts.com
;
;
(define (apply-ice-cube-logo-effect img inLayer inGrow inCube inIcicle inColor autocrop)
	(let*
		(
			(width (car (gimp-drawable-width inLayer)))
			(height (car (gimp-drawable-height inLayer)))

			(theIceLayer (car (gimp-layer-new img width height RGBA-IMAGE "Ice" 100 LAYER-MODE-NORMAL-LEGACY)))

			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))
		)

	(gimp-image-resize img width height 0 0)
	(gimp-image-insert-layer img theIceLayer 0 0)
	(gimp-edit-clear theIceLayer)

	(gimp-image-select-item img 0 inLayer)

	(if (> inGrow 0)
		(gimp-selection-grow img inGrow)
		
		(if (< inGrow 0)
			(gimp-selection-shrink img (- 0 inGrow))
		)
	)

	(gimp-context-set-foreground '(255 255 255))
	(gimp-edit-fill theIceLayer FILL-FOREGROUND)
	(gimp-selection-none img)

	(plug-in-cubism 1 img theIceLayer inCube 2.5 0)

	(if (> inIcicle 0)
		(begin
			(plug-in-rotate 1 img theIceLayer 1 FALSE)
			(plug-in-wind 1 img theIceLayer 10 1 inIcicle 1 1)
			(plug-in-rotate 1 img theIceLayer 3 FALSE)
		)
	)

	(plug-in-gauss-iir 1 img theIceLayer 3 TRUE TRUE)

	(define (set-pt a index x y)
		(begin
			(aset a (* index 2) x)
			(aset a (+ (* index 2) 1) y)
		)
	)

	(define (splineValue)
		(let* 
			(
				(a (cons-array 18 'byte))
			)
			
		(set-pt a 0 0 0)
		(set-pt a 1 32 32)
		(set-pt a 2 64 120)
		(set-pt a 3 96 72)
		(set-pt a 4 128 184)
		(set-pt a 5 160 126)
		(set-pt a 6 192 224)
		(set-pt a 7 224 184)
		(set-pt a 8 255 255)
		a
		)
	)
	
	(gimp-curves-spline theIceLayer HISTOGRAM-VALUE 18 (splineValue))

	;(define red (larg-default inColor 0 0))
	(define red (nth 0 inColor))
	
	(if (= red 0)
		(set! red 1)
		
		(if (= red 255)
			(set! red 254)
		)
	)

	;(define green (larg-default inColor 1 0))
	(define green (nth 1 inColor))
	
	(if (= green 0)
		(set! green 1)
		
		(if (= green 255)
			(set! green 254)
		)
	)

	;(define blue (larg-default inColor 2 0))
	(define blue (nth 2 inColor))
	
	(if (= blue 0)
		(set! blue 1)
		
		(if (= blue 255)
			(set! blue 254)
		)
	)
	
	(define gray (/ (+ (* red 299) (* green 587) (* blue 114)) 1000))

	(define (splineRed)
	(let* 
		(
			(a (cons-array 6 'byte))
		)
		
		(set-pt a 0 0 0)
		(set-pt a 1 gray red)
		(set-pt a 2 255 255)
		a
		)
	)
	
	(gimp-curves-spline theIceLayer HISTOGRAM-RED 6 (splineRed))

	(define (splineGreen)
		(let* 
			(
				(a (cons-array 6 'byte))
			)
			
		(set-pt a 0 0 0)
		(set-pt a 1 gray green)
		(set-pt a 2 255 255)
		a
		)
	)
	
	(gimp-curves-spline theIceLayer  HISTOGRAM-GREEN 6 (splineGreen))

	(define (splineBlue)
		(let* 
			(
				(a (cons-array 6 'byte))
			)
			
		(set-pt a 0 0 0)
		(set-pt a 1 gray blue)
		(set-pt a 2 255 255)
		a
		)
	)
	
	(gimp-curves-spline theIceLayer HISTOGRAM-BLUE 6 (splineBlue))

	(gimp-curves-spline theIceLayer HISTOGRAM-ALPHA 18 (splineValue))

		; ajout samj
		(if 
			(= autocrop TRUE) 
				(plug-in-autocrop 1 img theIceLayer)
		)	
	
	(gimp-context-set-background old-bg)
	(gimp-context-set-foreground old-fg)
	)
)

(define (script-fu-ice-cube-alpha img theLayer inGrow inCube inIcicle inIceColor)
	(begin
		(gimp-image-undo-group-start img)

		(apply-ice-cube-logo-effect img theLayer inGrow inCube inIcicle inIceColor 0)

		(gimp-image-undo-group-end img)
		(gimp-displays-flush)
	)
)

(script-fu-register "script-fu-ice-cube-alpha"
	;_"<Image>/Script-Fu/Logos/Ice Cube..."
	_"<Image>/Filters/Alpha to Logo/Ice Cube..."
	"Creates a ice-cube logo."
	"Michael Schalla"
	"Michael Schalla"
	"Februar 2001"
	"RGBA"
	SF-IMAGE "Image" 0
	SF-DRAWABLE "Drawable" 0
	SF-ADJUSTMENT "Grow" '(-2 -50 50 1 1 0 1)
	SF-ADJUSTMENT "Cube-Dimension" '(8 4 50 1 1 0 1)
	SF-ADJUSTMENT "Icicle" '(5 0 100 1 1 0 1)
	SF-COLOR "Ice Color" '(32 64 128)
)

(define (script-fu-ice-cube-logo inText inFont inFontSize inIceColor inBackGroundColor inGrow inCube inIcicle inAbsolute inImageWidth inImageHeight inFlatten autocrop)
	(let*
		(
			; Definition unserer lokalen Variablen

			; Erzeugen des neuen Bildes

			(img (car (gimp-image-new 10 10 RGB)))
			(theText)
			(theTextWidth)
			(theTextHeight)
			(imgWidth)
			(imgHeight)
			(theBufferX)
			(theBufferY)

			; Erzeugen einer neuen Ebene zum Bild
			(theLayer (car (gimp-layer-new img 10 10 RGB-IMAGE "Ebene 1" 100 LAYER-MODE-NORMAL-LEGACY)))
			(theTextLayer (car (gimp-layer-new img 10 10 RGBA-IMAGE "Ebene 2" 100 LAYER-MODE-NORMAL-LEGACY)))

			(old-fg (car (gimp-context-get-foreground)))
			(old-bg (car (gimp-context-get-background)))
			; Ende unserer lokalen Variablen
			
			(interpolation)
		)

		(gimp-image-insert-layer img theLayer 0 0)
		(gimp-image-insert-layer img theTextLayer 0 0)

		; zum Anzeigen des leeren Bildes
		; (gimp-display-new img)

		(gimp-context-set-background inBackGroundColor )
		(gimp-context-set-foreground inIceColor)

		(gimp-selection-all img)
		(gimp-edit-clear theLayer)
		(gimp-edit-clear theTextLayer)
		(gimp-selection-none img)

		(set! theText (car (gimp-text-fontname img theTextLayer 0 0 inText 0 TRUE inFontSize PIXELS inFont)))

		(set! theTextWidth (car (gimp-drawable-width theText)))
		(set! theTextHeight (car (gimp-drawable-height theText)))

	(set! imgWidth inImageWidth )
	(set! imgHeight inImageHeight )

	;modif samj
	;(if (= inAbsolute FALSE)
		(set! imgWidth (+ theTextWidth theTextHeight ))
	;)

	;modif samj
	;(if (= inAbsolute FALSE)
		(set! imgHeight (+ (* theTextHeight 1.5 ) (* inIcicle 2)))
	;)

	(set! theBufferX (/ (- imgWidth theTextWidth) 2))
	(set! theBufferY (/ (- imgHeight theTextHeight) 2))

	(gimp-image-resize img imgWidth imgHeight 0 0)
	(gimp-layer-resize theLayer imgWidth imgHeight 0 0)
	(gimp-layer-resize theTextLayer imgWidth imgHeight 0 0)

	(gimp-layer-set-offsets theText theBufferX theBufferY)
	(gimp-floating-sel-anchor theText)

	(apply-ice-cube-logo-effect img theTextLayer inGrow inCube inIcicle inIceColor autocrop)

	(if (= inFlatten TRUE)
		(gimp-image-flatten img)
	()
	)


	; modif samj
	(if 
		(= inAbsolute TRUE)
			(begin
				; aplatir et redimensionner image
				(set! interpolation (car (gimp-context-get-interpolation)))
				(gimp-image-flatten img)
				(gimp-image-resize img inImageWidth inImageHeight 0 0)
				(gimp-layer-scale (car (gimp-image-get-active-layer img)) inImageWidth inImageHeight FALSE)
				(gimp-context-set-interpolation 2) ; cubic
				(gimp-layer-resize (car (gimp-image-get-active-layer img)) inImageWidth inImageHeight 0 0)
				(gimp-context-set-interpolation interpolation)
			)
	)		
	
	
	
	(gimp-context-set-background old-bg)
	(gimp-context-set-foreground old-fg)

	(gimp-display-new img)
	(list img theLayer theText)

	)
)

(script-fu-register
	"script-fu-ice-cube-logo"
	;"<Toolbox>/Xtns/Script-Fu/Logos/Ice Cube..."
	"<Image>/File/Create/Logos/Ice Cube..."
	"Creates a ice-cube logo."
	"Michael Schalla"
	"Michael Schalla"
	"October 2002"
	""
	;SF-STRING "Text" "ice cube"
	SF-STRING "Text" "Gimp 2.10 "
	;SF-FONT "Font" "-*-Arial Black-*-r-*-*-24-*-*-*-p-*-*-*"
	SF-FONT "Font" "Arial Black"
	SF-ADJUSTMENT "Font Size" '(130 2 1000 1 10 0 1)
	SF-COLOR "Ice Color" '(32 64 128)
	SF-COLOR "BG Color" '(0 0 0)
	SF-ADJUSTMENT "Grow" '(-2 -50 50 1 1 0 1)
	SF-ADJUSTMENT "Cube-Dimension" '(8 4 50 1 1 0 1)
	SF-ADJUSTMENT "Icicle" '(5 0 100 1 1 0 1)
	;SF-TOGGLE "Absolute Size?" FALSE
	SF-TOGGLE "Absolute Size and Flatten?" FALSE
	SF-VALUE "Image Width" "400"
	SF-VALUE "Image Height" "150"
	SF-TOGGLE "Flatten Layers?" FALSE
	SF-TOGGLE "Autocrop logo" TRUE
)

; FIN du script
